#include <stdio.h>
#include <sys/time.h>
#include <time.h>
#include <string.h>
#include <stdlib.h>  

//struct timeval end;

struct info
{
	char *s;
	struct timeval start;
	struct timeval end;
	long int time;
};
int count= 0;
struct info infos[5000];

int timer_arnamoy_start ( char * name)
{
	char *aux;
	aux=getenv("PROFILE_MODEL");
	
	if(aux == NULL)
		return 0;
	int env = atoi(aux);
	
	if (env == 0)
		return 0;
	
	int i;
	for(i= 0; i<count; i++)
	{
		if(strcmp(infos[i].s,name) == 0)
		{
			gettimeofday(&infos[i].start, NULL);
			
			return 1;
		}
		
	}
		
		infos[count].s = name;
		infos[count].time = -444;
	
		gettimeofday(&infos[count].start, NULL);
		count++;
		return 1;
	
	//printf("%s starts at %ld\n",name,t1);
}
int timer_arnamoy_end ( char * name)
{
	char *aux;
	aux=getenv("PROFILE_MODEL");
	
	if(aux == NULL)
		return 0;
	int env = atoi(aux);
	
	if (env == 0)
		return 0;
	int i = 0;
	for(i= 0; i<count; i++)
	{
		if(strcmp(infos[i].s,name) == 0)
		{
			gettimeofday(&infos[i].end, NULL);
			long int taken;
			//check if it is a long running program or a short running one
			if((infos[i].end.tv_sec-infos[i].start.tv_sec)>200)
				taken = infos[i].end.tv_sec - infos[i].start.tv_sec;
			else
				taken = ((infos[i].end.tv_sec * 1000000 + infos[i].end.tv_usec)
						- (infos[i].start.tv_sec * 1000000 + infos[i].start.tv_usec));
			//printf("%s start %ld end %ld taken  %ld\n",name,(infos[i].start.tv_sec * 1000000 + infos[i].start.tv_usec),
			//		(end.tv_sec * 1000000 + end.tv_usec),taken);
		    if(infos[i].time<0)
				infos[i].time = taken;
			else
				infos[i].time+=taken;

		    break;
		}
	 }
	 return 1;
}
int print_kernels_arnamoy()
{
	char *aux;
	aux=getenv("PROFILE_MODEL");
	
	if(aux == NULL)
		return 0;
	int env = atoi(aux);
	
	if (env == 0)
		return 0;
	
	long int total_taken=0;
	int i;
	for(i= 0; i<count; i++)
	{
		total_taken+=infos[i].time;

	 }
	 for(i= 0; i<count; i++)
	{
		//double percentage = ((double)infos[i].time/(double)total_taken)*100;
		printf("time taken by %s %ld of %ld\n",infos[i].s,infos[i].time,total_taken);
		
		//create a command a write to the profile file
		char str[100];
		strcpy(str,"echo '");
		strcat(str,infos[i].s);
		char time[25];
		sprintf (time, "%ld" , infos[i].time);
		strcat(str,"****");
		strcat(str, time);
		strcat(str, "' >>profile.txt");
		
		system(str);
		
		//printf("%s takes %f percent of program\n",infos[i].s,percentage);
	 }
	 char str1[20];
	 strcpy(str1,"echo '----'>>profile.txt");
	 system(str1);
	 return 1;
}

/*int profile_count(char * s, int count)
{
	char *aux;
	aux=getenv("PROFILE_MODEL");
	
	if(aux == NULL)
		return 0;
	int env = atoi(aux);
	
	if (env == 0)
		return 0;
	printf("%s has iteration count %d\n",s,count);
	return 1;
}*/

//normal values
int profile_int(char * s, int val)
{
	char *aux;
	aux=getenv("PROFILE_MODEL");
	
	if(aux == NULL)
		return 0;
	int env = atoi(aux);
	
	if (env == 0)
		return 0;
		//create a command a write to the profile file
		char str[100];
		strcpy(str,"echo '");
		strcat(str,s);
		char time[25];
		sprintf (time, "%d" , val);
		strcat(str,"$$");
		strcat(str, time);
		strcat(str, "' >>profile.txt");
		
		system(str);
		return 1;
	//printf("%s using value %d\n",s,val);
}
int profile_long(char * s, long val)
{
	char *aux;
	aux=getenv("PROFILE_MODEL");
	
	if(aux == NULL)
		return 0;
	int env = atoi(aux);
	
	if (env == 0)
		return 0;
			//create a command a write to the profile file
		char str[100];
		strcpy(str,"echo '");
		strcat(str,s);
		char time[25];
		sprintf (time, "%ld" , val);
		strcat(str,"$$");
		strcat(str, time);
		strcat(str, "' >>profile.txt");
		
		system(str);
		return 1;
	//printf("%s using value %ld\n",s,val);
}
int profile_float(char * s, float val)
{
	char *aux;
	aux=getenv("PROFILE_MODEL");
	
	if(aux == NULL)
		return 0;
	int env = atoi(aux);
	
	if (env == 0)
		return 0;
			//create a command a write to the profile file
		char str[100];
		strcpy(str,"echo '");
		strcat(str,s);
		char time[25];
		sprintf (time, "%f" , val);
		strcat(str,"$$");
		strcat(str, time);
		strcat(str, "' >>profile.txt");
		
		system(str);
		return 1;
	//printf("%s using value %f\n",s,val);
}
int profile_double(char * s, double val)
{
	char *aux;
	aux=getenv("PROFILE_MODEL");
	
	if(aux == NULL)
		return 0;
	int env = atoi(aux);
	
	if (env == 0)
		return 0;
			//create a command a write to the profile file
		char str[100];
		strcpy(str,"echo '");
		strcat(str,s);
		char time[25];
		sprintf (time, "%f" , val);
		strcat(str,"$$");
		strcat(str, time);
		strcat(str, "' >>profile.txt");
		
		system(str);
		return 1;
	//printf("%s using value %ld\n",s,val);
}

//pointers
/*int profile_single_pointer(char * s, int* ptr)
{
	char *aux;
	aux=getenv("PROFILE_MODEL");
	
	if(aux == NULL)
		return 1;
	int env = atoi(aux);
	
	if (env == 0)
		return 0;
	
	printf("%s using value %d\n",s,*ptr);
	return 1;
}*/

