#!/bin/bash

for var in "$@"
do
    #echo "$var"
    $GCC -S $OPTIONS -fplugin=$DRAGONEGG/dragonegg.so -fplugin-arg-dragonegg-emit-ir $var$EXTENSION -o $var.o
    $LLVM/Release+Asserts/bin/opt -load $LLVM/Release+Asserts/lib/KernelInst.so -kernel-inst <$var.o> $var.bc
    $LLVM/Release+Asserts/bin/opt -load $LLVM/Release+Asserts/lib/ParaProf.so -paraprof <$var.bc> $var.bc1
    $LLVM/Release+Asserts/bin/opt -load $LLVM/Release+Asserts/lib/ParaRec.so -pararec <$var.bc1> $var.bc2
    $LLVM/Release+Asserts/bin/opt -load $LLVM/Release+Asserts/lib/ValueInst.so -value-inst <$var.bc2> $var.bc3
    
done

 
$LLVM/Release+Asserts/bin/llvm-link *.bc3 -S -o pemogen_inst.bc
$LLVM/Release+Asserts/bin/llc pemogen_inst.bc
$GCC $OPTIONS pemogen_inst.bc -o pemogen_inst

