#include <stdio.h>
#include <sys/time.h>
#include <time.h>
#include <string.h>
#include <execinfo.h>
#include <stdlib.h>



struct timeval end;

struct info
{
	char * s;
	struct timeval start;
	long int time;
};
int count= 0;
struct info infos[5000];
void dump_trace();
char chain[5000] = "";


void dump_trace_() {
        void *bt[1024];
        int bt_size;
        char **bt_syms;
        int i;

        bt_size = backtrace(bt, 1024);
        bt_syms = backtrace_symbols(bt, bt_size);
        //full_write(STDERR_FILENO, start, strlen(start));
		strcpy(chain,"");
        printf("Inside backtrace size %d\n",bt_size);
        for (i = 0; i < (bt_size -4); i++) {
                //size_t len = strlen(bt_syms[i]);
                //full_write(STDERR_FILENO, bt_syms[i], len);
                //full_write(STDERR_FILENO, "\n", 1);
                printf("%s\n",bt_syms[i]);
                
                //tokenize to ge the call chain
                
                char  to[500]="";
                char  from[500]="";
                

				strcpy(from,  bt_syms[i]);

				

                //now there can be two cases
                //get location of opening bracket
                char * pch = strchr(from, '(');
                int l = pch-from+1;

				
				//get location of +
                char * pch1 = strchr(from,'+');                
                int j = pch1-from-1;
					
				int how_many = j-l+1;
				//printf("%s %d %d %d\n",bt_syms[i],l,j,how_many);
				strncpy (to,from+l,how_many);
               
               strcat(chain,to);
               
                if(i!=bt_size-3)
					strcat(chain,"->");
				printf("%s\n",chain);
        }
        printf("%s\n",chain);
        //std::cout << chain << '\n';
        //full_write(STDERR_FILENO, end, strlen(end));
        //printf("Inside %s\n",chain);
    free(bt_syms);
    return;
}


/*int timer_arnamoy_start ( char * name1)
{
	std::string call_chain = dump_trace();
	char *name = new char[call_chain.length() + 1];
	strcpy(name, call_chain.c_str());
	strcat(name,"->");
	strcat(name,name1);
	int i;
	for(i= 0; i<count; i++)
	{
		if(strcmp(infos[i].s,name) == 0)
		{
			gettimeofday(&infos[i].start, NULL);
			
			return 1;
		}
		
	}
		
		infos[count].s = name;
		infos[count].time = -444;
	
		gettimeofday(&infos[count].start, NULL);
		count++;
	
	//printf("%s starts at %ld\n",name,t1);
}
int timer_arnamoy_end ( char * name1)
{
	std::string call_chain = dump_trace();
	char *name = new char[call_chain.length() + 1];
	strcpy(name, call_chain.c_str());
	strcat(name,"->");
	strcat(name,name1);
	int i = 0;
	for(i= 0; i<count; i++)
	{
		if(strcmp(infos[i].s,name) == 0)
		{
			gettimeofday(&end, NULL);
			long int taken;
			//check if it is a long running program or a short running one
			if(end.tv_sec>200)
				taken = end.tv_sec - infos[i].start.tv_sec;
			else
				taken = ((end.tv_sec * 1000000 + end.tv_usec)
						- (infos[i].start.tv_sec * 1000000 + infos[i].start.tv_usec));
			//printf("%s start %ld end %ld taken  %ld\n",name,(infos[i].start.tv_sec * 1000000 + infos[i].start.tv_usec),
			//		(end.tv_sec * 1000000 + end.tv_usec),taken);
		    if(infos[i].time<0)
				infos[i].time = taken;
			else
				infos[i].time+=taken;

		    break;
		}
	 }
}
int print_kernels_arnamoy()
{
	
	long int total_taken=0;
	int i;
	for(i= 0; i<count; i++)
	{
		total_taken+=infos[i].time;

	 }
	 for(i= 0; i<count; i++)
	{
		double percentage = ((double)infos[i].time/(double)total_taken)*100;
		//printf("time taken by %s %ld of %ld\n",infos[i].s,infos[i].time,main_taken);
		
		printf("%s takes %f percent of program\n",infos[i].s,percentage);
	 }
}

int profile_count(char * s, int count)
{
	printf("%s has iteration count %ld\n",s,count);
}

//normal values
int profile_int(char * s, int val)
{
	printf("%s using value %d\n",s,val);
}
int profile_long(char * s, long val)
{
	printf("%s using value %ld\n",s,val);
}
int profile_float(char * s, float val)
{
	printf("%s using value %f\n",s,val);
}
int profile_double(char * s, double val)
{
	printf("%s using value %ld\n",s,val);
}

//pointers
int profile_single_pointer(char * s, int* ptr)
{
	
	printf("%s using value %d\n",s,ptr);
}
*/

